module DataPath(input clk,Wen,IFIDWrite,R0Write,rst,Br,MemToReg,writeMem,input[1:0]PcSel,ALU0,ALU1,input[8:0] ALUop,
                output zeroFlag,output[15:0] inss,output Stall);
  wire[11:0] outPcSel,outPC,PCReg,outInc;
  wire[15:0] ins,insReg,outMemToReg,readData,readR0Data,imd,ReadDataReg,ReadR0DataReg,imdReg,outF0,outF1,outALU0mux,outALU1mux,ALUout,adrReg,WriteDataOut,ALUReg,Memout,Memreg,ALUreg;
  wire[1:0] WBreg,ALU0S,ALU1S,WBregE,WBregW;
  wire Mreg,MregE,MemToRegReg;
  wire[2:0] writeRReg,R0out,writeRRegE,writeRRegW;
  wire[13:0] EXreg;
  wire[3:0] IFIDopc,IFIDopcReg,IDEXopcReg,EXMEMopcReg,MEMWBopcReg;
  wire stall;
  pc p(outPcSel,Br,clk,rst,outPC);
  insMem im(outPC,ins);
  IFID ifid(clk,IFIDopc,IFIDWrite,outPC,ins,insReg,PCReg,IFIDopcReg);
  inc i(PCReg,outInc);
  regFile rf(WBregW[1],clk,insReg[11:9],writeRRegW,outMemToReg,readData,readR0Data);
  signExt se(insReg[11:0],imd);
  muxPC pc(outInc, insReg[11:0],{PCReg[11:9],insReg[8:0]},PcSel,outPcSel);
  IDEX idex(clk,IFIDopcReg,{Wen,MemToReg},writeMem,{R0Write,ALU0,ALU1,ALUop},readData,readR0Data,imd,insReg[11:9],WBreg,Mreg,EXreg,ReadDataReg,ReadR0DataReg,imdReg,writeRReg,IDEXopcReg); 
  muxForward0 f0(ReadDataReg,ALUreg,outMemToReg,ALU0S,outF0);
  muxForward0 f1(ReadR0DataReg,ALUreg,outMemToReg,ALU1S,outF1);
  muxALU0 A0(imdReg,outF0,EXreg[12:11],outALU0mux);
  muxALU1 A1(outF1,EXreg[10:9],outALU1mux);
  muxRegWrite rw(writeRReg,EXreg[13],R0out);
  ALU alu(outALU0mux,outALU1mux,EXreg[8:0],ALUout);
  ForwardUnit fu(EXMEMopcReg,WBregW[1],WBregE[1],R0out,writeRRegE,writeRRegW,ALU0S,ALU1S,stall);
  EXMEM exmem(clk,IDEXopcReg,WBreg,Mreg,imdReg,ReadR0DataReg,ALUout,R0out,WBregE,MregE,adrReg,WriteDataOut,ALUReg,writeRRegE,EXMEMopcReg); 
  mem m(adrReg,WriteDataOut,clk,MregE,Memout);
  MEMWB memwb(clk,EXMEMopcReg,WBregE,Memout,ALUReg,writeRRegE,WBregW,Memreg,ALUreg,writeRRegW,MEMWBopcReg);
  memToReg mtr(WBregW[0],ALUreg,Memreg,outMemToReg);
  assign inss=ins;
  assign zeroFlag=(readData==readR0Data)?1:0;
  assign IFIDopc=ins[15:12];
  assign Stall=stall;
endmodule